; PATCH file B
; for Pac-Tape v1.0
; Copyright (C) 1997  by Sean Gugler
; a derivative work from M.A.M.E. v0.28
; Copyright (C) 1997  by Nicola Salmoria and the MAME team
;
; *** To be applied after patch file A! ***
; 
; Modifies the following files:
;   src/mame.c
;   src/driver.c
;   src/cpuintrf.c
;   makefile
;
;--------------------------------------------------------------------------
;
diff -rC2 s0/src/mame.c s1/src/mame.c
*** s0/src/mame.c	Wed Oct  1 18:25:10 1997
--- s1/src/mame.c	Wed Oct  3 18:13:42 1997
***************
*** 81,90 ****
  	if (help)    /* brief help - useful to get current version info */
  	{
! 		printf("M.A.M.E. v%s - Multiple Arcade Machine Emulator\n"
! 		       "Copyright (C) 1997  by Nicola Salmoria and the MAME team\n\n"
!  		       "-- includes Pac-Tape v1.0 module: \"Tape\" recorder for Pac-Man games\n"
!  		       "Copyright (C) 1997  by Sean Gugler\n\n",mameversion);
  		showdisclaimer();
! 		printf("Usage:  MAME gamename [options]\n");
  
  		return 0;
--- 81,91 ----
  	if (help)    /* brief help - useful to get current version info */
  	{
!  		printf("Pac-Tape v1.0 - \"Tape\" recorder for Pac-Man games\n"
!  		       "Copyright (C) 1997  by Sean Gugler\n\n"
!  		       "This work is a derivative work of:\n"
! 		       "M.A.M.E. v%s - Multiple Arcade Machine Emulator\n"
! 		       "Copyright (C) 1997  by Nicola Salmoria and the MAME team\n\n",mameversion);
  		showdisclaimer();
! 		printf("Usage:  PACTAPE gamename [options]\n");
  
  		return 0;
***************
*** 102,106 ****
  	{
  		case 1:      /* simple games list */
! 			printf("\nMAME currently supports the following games:\n\n");
  			i = 0;
  			while (drivers[i])
--- 103,107 ----
  	{
  		case 1:      /* simple games list */
! 			printf("\nPACTAPE currently supports the following games:\n\n");
  			i = 0;
  			while (drivers[i])
diff -rC2 s0/src/driver.c s1/src/driver.c
*** s0/src/driver.c	Sun Sep  7 10:34:08 1997
--- s1/src/driver.c	Tue Sep  9 11:27:48 1997
***************
*** 5,9 ****
  extern struct GameDriver pacman_driver;
  extern struct GameDriver pacplus_driver;
- extern struct GameDriver jrpacman_driver;
  extern struct GameDriver pacmod_driver;
  extern struct GameDriver namcopac_driver;
--- 5,8 ----
***************
*** 12,238 ****
  extern struct GameDriver puckman_driver;
  extern struct GameDriver piranha_driver;
- extern struct GameDriver mspacman_driver;
- extern struct GameDriver mspacatk_driver;
- extern struct GameDriver crush_driver;
- extern struct GameDriver pengo_driver;
- extern struct GameDriver pengoa_driver;
- extern struct GameDriver penta_driver;
- extern struct GameDriver ladybug_driver;
- extern struct GameDriver snapjack_driver;
- extern struct GameDriver cavenger_driver;
- extern struct GameDriver mrdo_driver;
- extern struct GameDriver mrdot_driver;
- extern struct GameDriver mrlo_driver;
- extern struct GameDriver docastle_driver;
- extern struct GameDriver docastl2_driver;
- extern struct GameDriver dounicorn_driver;
- extern struct GameDriver dowild_driver;
- extern struct GameDriver dorunrun_driver;
- extern struct GameDriver kickridr_driver;
- extern struct GameDriver cclimber_driver;
- extern struct GameDriver ccjap_driver;
- extern struct GameDriver ccboot_driver;
- extern struct GameDriver seicross_driver;
- extern struct GameDriver ckong_driver;
- extern struct GameDriver ckonga_driver;
- extern struct GameDriver ckongjeu_driver;
- extern struct GameDriver ckongs_driver;
- extern struct GameDriver dkong_driver;
- extern struct GameDriver dkongjp_driver;
- extern struct GameDriver dkongjr_driver;
- extern struct GameDriver dkong3_driver;
- extern struct GameDriver mario_driver;
- extern struct GameDriver bagman_driver;
- extern struct GameDriver sbagman_driver;
- extern struct GameDriver wow_driver;
- extern struct GameDriver robby_driver;
- extern struct GameDriver gorf_driver;
- extern struct GameDriver seawolf_driver;
- extern struct GameDriver spacezap_driver;
- extern struct GameDriver galaxian_driver;
- extern struct GameDriver galmidw_driver;
- extern struct GameDriver galnamco_driver;
- extern struct GameDriver superg_driver;
- extern struct GameDriver galapx_driver;
- extern struct GameDriver galap1_driver;
- extern struct GameDriver galap4_driver;
- extern struct GameDriver galturbo_driver;
- extern struct GameDriver pisces_driver;
- extern struct GameDriver japirem_driver;
- extern struct GameDriver uniwars_driver;
- extern struct GameDriver warofbug_driver;
- extern struct GameDriver mooncrst_driver;
- extern struct GameDriver mooncrsb_driver;
- extern struct GameDriver fantazia_driver;
- extern struct GameDriver moonqsr_driver;
- extern struct GameDriver scramble_driver;
- extern struct GameDriver atlantis_driver;
- extern struct GameDriver theend_driver;
- extern struct GameDriver froggers_driver;
- extern struct GameDriver scobra_driver;
- extern struct GameDriver scobrak_driver;
- extern struct GameDriver scobrab_driver;
- extern struct GameDriver losttomb_driver;
- extern struct GameDriver anteater_driver;
- extern struct GameDriver rescue_driver;
- extern struct GameDriver hunchy_driver;
- extern struct GameDriver frogger_driver;
- extern struct GameDriver frogsega_driver;
- extern struct GameDriver amidar_driver;
- extern struct GameDriver amidarjp_driver;
- extern struct GameDriver amigo_driver;
- extern struct GameDriver turtles_driver;
- extern struct GameDriver turpin_driver;
- extern struct GameDriver rallyx_driver;
- extern struct GameDriver pooyan_driver;
- extern struct GameDriver timeplt_driver;
- extern struct GameDriver spaceplt_driver;
- extern struct GameDriver locomotn_driver;
- extern struct GameDriver phoenix_driver;
- extern struct GameDriver phoenixt_driver;
- extern struct GameDriver phoenix3_driver;
- extern struct GameDriver pleiads_driver;
- extern struct GameDriver carnival_driver;
- extern struct GameDriver invaders_driver;
- extern struct GameDriver earthinv_driver;
- extern struct GameDriver spaceatt_driver;
- extern struct GameDriver invrvnge_driver;
- extern struct GameDriver invdelux_driver;
- extern struct GameDriver galxwars_driver;
- extern struct GameDriver lrescue_driver;
- extern struct GameDriver desterth_driver;
- extern struct GameDriver zaxxon_driver;
- extern struct GameDriver congo_driver;
- extern struct GameDriver bombjack_driver;
- extern struct GameDriver centiped_driver;
- extern struct GameDriver milliped_driver;
- extern struct GameDriver warlord_driver;
- extern struct GameDriver nibbler_driver;
- extern struct GameDriver fantasy_driver;
- extern struct GameDriver mpatrol_driver;
- extern struct GameDriver mranger_driver;
- extern struct GameDriver btime_driver;
- extern struct GameDriver btimea_driver;
- extern struct GameDriver jumpbug_driver;
- extern struct GameDriver jbugsega_driver;
- extern struct GameDriver vanguard_driver;
- extern struct GameDriver gberet_driver;
- extern struct GameDriver rushatck_driver;
- extern struct GameDriver venture_driver;
- extern struct GameDriver mtrap_driver;
- extern struct GameDriver pepper2_driver;
- 
- extern struct GameDriver qbert_driver;
- extern struct GameDriver qbertjp_driver;
- extern struct GameDriver qbertqub_driver;
- extern struct GameDriver krull_driver;
- extern struct GameDriver reactor_driver;
- extern struct GameDriver mplanets_driver;
- extern struct GameDriver stooges_driver;
- 
- extern struct GameDriver junglek_driver;
- extern struct GameDriver jhunt_driver;
- extern struct GameDriver elevator_driver;
- extern struct GameDriver elevatob_driver;
- extern struct GameDriver panic_driver;
- extern struct GameDriver panica_driver;
- extern struct GameDriver arabian_driver;
- extern struct GameDriver c1942_driver;
- extern struct GameDriver vulgus_driver;
- extern struct GameDriver commando_driver;
- extern struct GameDriver commandj_driver;
- extern struct GameDriver gng_driver;
- extern struct GameDriver sonson_driver;
- extern struct GameDriver exedexes_driver;
- extern struct GameDriver popeyebl_driver;
- extern struct GameDriver warpwarp_driver;
- extern struct GameDriver gyruss_driver;
- extern struct GameDriver superpac_driver;
- extern struct GameDriver pacnpal_driver;
- extern struct GameDriver kangaroo_driver;
- extern struct GameDriver galaga_driver;
- extern struct GameDriver galaganm_driver;
- extern struct GameDriver galagabl_driver;
- extern struct GameDriver gallag_driver;
- extern struct GameDriver gngcross_driver;
- extern struct GameDriver diamond_driver;
- extern struct GameDriver kungfum_driver;
- extern struct GameDriver kungfub_driver;
- extern struct GameDriver qix_driver;
- 
- extern struct GameDriver robotron_driver;
- extern struct GameDriver stargate_driver;
- extern struct GameDriver joust_driver;
- extern struct GameDriver sinistar_driver;
- extern struct GameDriver bubbles_driver;
- extern struct GameDriver defender_driver;
- extern struct GameDriver splat_driver;
- extern struct GameDriver blaster_driver;
- 
- extern struct GameDriver starforc_driver;
- extern struct GameDriver naughtyb_driver;
- extern struct GameDriver popflame_driver;
- extern struct GameDriver mystston_driver;
- extern struct GameDriver frontlin_driver;
- extern struct GameDriver wwestern_driver;
- extern struct GameDriver spacefb_driver;
- extern struct GameDriver tutankhm_driver;
- extern struct GameDriver mappy_driver;
- extern struct GameDriver digdug2_driver;
- extern struct GameDriver ccastles_driver;
- extern struct GameDriver yiear_driver;
- extern struct GameDriver digdugnm_driver;
- extern struct GameDriver digdugat_driver;
- extern struct GameDriver asteroid_driver;
- extern struct GameDriver asteroi2_driver;
- extern struct GameDriver astdelux_driver;
- extern struct GameDriver bwidow_driver;
- extern struct GameDriver bzone_driver;
- extern struct GameDriver bzone2_driver;
- extern struct GameDriver gravitar_driver;
- extern struct GameDriver llander_driver;
- extern struct GameDriver redbaron_driver;
- extern struct GameDriver spacduel_driver;
- extern struct GameDriver tempest_driver;
- extern struct GameDriver starwars_driver;
- extern struct GameDriver missile_driver;
- extern struct GameDriver bublbobl_driver;
- extern struct GameDriver boblbobl_driver;
- extern struct GameDriver eggs_driver;
- extern struct GameDriver bosco_driver;
- extern struct GameDriver yard_driver;
- extern struct GameDriver blueprnt_driver;
- extern struct GameDriver spacfury_driver;
- extern struct GameDriver zektor_driver;
- extern struct GameDriver tacscan_driver;
- extern struct GameDriver elim2_driver;
- extern struct GameDriver startrek_driver;
- extern struct GameDriver omegrace_driver;
- extern struct GameDriver xevious_driver;
- extern struct GameDriver xeviousn_driver;
- extern struct GameDriver sxevious_driver;
- extern struct GameDriver bankp_driver;
- extern struct GameDriver sbasketb_driver;
- 
- /* MCR games */
- extern struct GameDriver kick_driver;
- extern struct GameDriver solarfox_driver;
- extern struct GameDriver tron_driver;
- extern struct GameDriver twotiger_driver;
- extern struct GameDriver domino_driver;
- extern struct GameDriver shollow_driver;
- extern struct GameDriver wacko_driver;
- extern struct GameDriver kroozr_driver;
- extern struct GameDriver journey_driver;
- extern struct GameDriver tapper_driver;
- extern struct GameDriver dotron_driver;
- extern struct GameDriver destderb_driver;
- extern struct GameDriver timber_driver;
- extern struct GameDriver spyhunt_driver;
- extern struct GameDriver rampage_driver;
- /* end of MCR games */
- extern struct GameDriver espial_driver;
- extern struct GameDriver tp84_driver;
- extern struct GameDriver rastan_driver;
  
  
--- 11,14 ----
***************
*** 241,245 ****
  	&pacman_driver,
  	&pacplus_driver,
- 	&jrpacman_driver,
  	&pacmod_driver,
  	&namcopac_driver,
--- 17,20 ----
***************
*** 248,469 ****
  	&puckman_driver,
  	&piranha_driver,
- 	&mspacman_driver,
- 	&mspacatk_driver,
- 	&crush_driver,
- 	&pengo_driver,
- 	&pengoa_driver,
- 	&penta_driver,
- 	&ladybug_driver,
- 	&snapjack_driver,
- 	&cavenger_driver,
- 	&mrdo_driver,
- 	&mrdot_driver,
- 	&mrlo_driver,
- 	&docastle_driver,
- 	&docastl2_driver,
- 	&dounicorn_driver,
- 	&dowild_driver,
- 	&dorunrun_driver,
- 	&kickridr_driver,
- 	&cclimber_driver,
- 	&ccjap_driver,
- 	&ccboot_driver,
- 	&seicross_driver,
- 	&ckong_driver,
- 	&ckonga_driver,
- 	&ckongjeu_driver,
- 	&ckongs_driver,
- 	&dkong_driver,
- 	&dkongjp_driver,
- 	&dkongjr_driver,
- 	&dkong3_driver,
- 	&mario_driver,
- 	&bagman_driver,
- 	&sbagman_driver,
- 	&wow_driver,
- 	&robby_driver,
- 	&gorf_driver,
- 	&seawolf_driver,
- 	&spacezap_driver,
- 	&galaxian_driver,
- 	&galmidw_driver,
- 	&galnamco_driver,
- 	&superg_driver,
- 	&galapx_driver,
- 	&galap1_driver,
- 	&galap4_driver,
- 	&galturbo_driver,
- 	&pisces_driver,
- 	&japirem_driver,
- 	&uniwars_driver,
- 	&warofbug_driver,
- 	&mooncrst_driver,
- 	&mooncrsb_driver,
- 	&fantazia_driver,
- 	&moonqsr_driver,
- 	&scramble_driver,
- 	&atlantis_driver,
- 	&theend_driver,
- 	&froggers_driver,
- 	&scobra_driver,
- 	&scobrak_driver,
- 	&scobrab_driver,
- 	&losttomb_driver,
- 	&anteater_driver,
- 	&rescue_driver,
- 	&hunchy_driver,
- 	&frogger_driver,
- 	&frogsega_driver,
- 	&amidar_driver,
- 	&amidarjp_driver,
- 	&amigo_driver,
- 	&turtles_driver,
- 	&turpin_driver,
- 	&rallyx_driver,
- 	&locomotn_driver,
- 	&timeplt_driver,
- 	&spaceplt_driver,
- 	&pooyan_driver,
- 	&phoenix_driver,
- 	&phoenixt_driver,
- 	&phoenix3_driver,
- 	&pleiads_driver,
- 	&carnival_driver,
- 	&invaders_driver,
- 	&earthinv_driver,
- 	&spaceatt_driver,
- 	&invrvnge_driver,
- 	&invdelux_driver,
- 	&galxwars_driver,
- 	&lrescue_driver,
- 	&desterth_driver,
- 	&zaxxon_driver,
- 	&congo_driver,
- 	&bombjack_driver,
- 	&centiped_driver,
- 	&milliped_driver,
- 	&warlord_driver,
- 	&nibbler_driver,
- 	&fantasy_driver,
- 	&mpatrol_driver,
- 	&mranger_driver,
- 	&btime_driver,
- 	&btimea_driver,
- 	&jumpbug_driver,
- 	&jbugsega_driver,
- 	&vanguard_driver,
- 	&gberet_driver,
- 	&rushatck_driver,
- 	&venture_driver,
- 	&mtrap_driver,
- 	&pepper2_driver,
- 	&qbert_driver,
- 	&qbertjp_driver,
- 	&qbertqub_driver,
- 	&krull_driver,
- 	&reactor_driver,
- 	&mplanets_driver,
- 	&stooges_driver,
- 	&junglek_driver,
- 	&jhunt_driver,
- 	&elevator_driver,
- 	&elevatob_driver,
- 	&panic_driver,
- 	&panica_driver,
- 	&arabian_driver,
- 	&popeyebl_driver,
- 	&warpwarp_driver,
- 	&c1942_driver,
- 	&vulgus_driver,
- 	&commando_driver,
- 	&commandj_driver,
- 	&gng_driver,
- 	&sonson_driver,
- 	&exedexes_driver,
- 	&gyruss_driver,
- 	&superpac_driver,
- 	&pacnpal_driver,
- 	&kangaroo_driver,
- 	&galaga_driver,
- 	&galaganm_driver,
- 	&galagabl_driver,
- 	&gallag_driver,
- 	&gngcross_driver,
- 	&diamond_driver,
- 	&kungfum_driver,
- 	&kungfub_driver,
- 	&qix_driver,
- 	&robotron_driver,
- 	&stargate_driver,
- 	&joust_driver,
- 	&sinistar_driver,
- 	&bubbles_driver,
- 	&defender_driver,
- 	&splat_driver,
- 	&blaster_driver,
- 	&starforc_driver,
- 	&naughtyb_driver,
- 	&popflame_driver,
- 	&mystston_driver,
- 	&frontlin_driver,
- 	&wwestern_driver,
- 	&spacefb_driver,
- 	&tutankhm_driver,
- 	&mappy_driver,
- 	&digdug2_driver,
- 	&ccastles_driver,
- 	&yiear_driver,
- 	&digdugnm_driver,
- 	&digdugat_driver,
- 	&asteroid_driver,
- 	&asteroi2_driver,
- 	&astdelux_driver,
- 	&bwidow_driver,
- 	&bzone_driver,
- 	&bzone2_driver,
- 	&gravitar_driver,
- 	&llander_driver,
- 	&redbaron_driver,
- 	&spacduel_driver,
- 	&tempest_driver,
- 	&starwars_driver,
- 	&missile_driver,
- 	&bublbobl_driver,
- 	&boblbobl_driver,
- 	&eggs_driver,
- 	&bosco_driver,
- 	&yard_driver,
- 	&blueprnt_driver,
- 	&spacfury_driver,
- 	&zektor_driver,
- 	&tacscan_driver,
- 	&elim2_driver,
- 	&startrek_driver,
- 	&omegrace_driver,
- 	&xevious_driver,
- 	&xeviousn_driver,
- 	&sxevious_driver,
- 	&bankp_driver,
- 	&sbasketb_driver,
- 	/* MCR games */
- 	&kick_driver,
- 	&solarfox_driver,
- 	&tron_driver,
- 	&twotiger_driver,
- 	&domino_driver,
- 	&shollow_driver,
- 	&wacko_driver,
- 	&kroozr_driver,
- 	&journey_driver,
- 	&tapper_driver,
- 	&dotron_driver,
- 	&destderb_driver,
- 	&timber_driver,
- 	&spyhunt_driver,
- 	&rampage_driver,
- 	/* end of MCR games */
- 	&espial_driver,
- 	&tp84_driver,
- 	&rastan_driver,
  	0	/* end of array */
  };
--- 23,26 ----
diff -rC2 s0/makefile s1/makefile
*** s0/makefile	Wed Oct  1 18:25:10 1997
--- s1/makefile	Wed Sep 10 15:49:16 1997
***************
*** 10,135 ****
           obj/pactape/pactape.o obj/pactape/pactree.o obj/pactape/paclearn.o \
           obj/pactape/pacthink.o \
!          obj/sndhrdw/adpcm.o \
!          obj/sndhrdw/ym2203.opm obj/sndhrdw/psg.o obj/sndhrdw/8910intf.o \
! 		 obj/sndhrdw/pokey.o obj/sndhrdw/pokyintf.o obj/sndhrdw/sn76496.o \
! 		 obj/sndhrdw/votrax.o \
           obj/machine/z80fmly.o \
           obj/vidhrdw/generic.o obj/sndhrdw/generic.o \
-          obj/vidhrdw/vector.o obj/machine/mathbox.o \
           obj/machine/pacman.o obj/drivers/pacman.o \
!          obj/machine/jrpacman.o obj/drivers/jrpacman.o obj/vidhrdw/jrpacman.o \
!          obj/vidhrdw/pengo.o obj/sndhrdw/pengo.o obj/drivers/pengo.o \
!          obj/vidhrdw/ladybug.o obj/sndhrdw/ladybug.o obj/drivers/ladybug.o \
!          obj/machine/mrdo.o obj/vidhrdw/mrdo.o obj/drivers/mrdo.o \
!          obj/machine/docastle.o obj/vidhrdw/docastle.o obj/sndhrdw/docastle.o obj/drivers/docastle.o \
!          obj/drivers/dowild.o \
!          obj/vidhrdw/cclimber.o obj/sndhrdw/cclimber.o obj/drivers/cclimber.o \
!          obj/drivers/ckongs.o \
!          obj/machine/seicross.o obj/sndhrdw/seicross.o obj/vidhrdw/seicross.o obj/drivers/seicross.o \
!          obj/vidhrdw/dkong.o obj/sndhrdw/dkong.o obj/drivers/dkong.o \
!          obj/machine/bagman.o obj/vidhrdw/bagman.o obj/sndhrdw/bagman.o obj/drivers/bagman.o \
!          obj/machine/wow.o obj/vidhrdw/wow.o obj/sndhrdw/wow.o obj/drivers/wow.o \
!          obj/vidhrdw/galaxian.o obj/drivers/galaxian.o \
!          obj/sndhrdw/mooncrst.o obj/drivers/mooncrst.o \
!          obj/drivers/moonqsr.o \
!          obj/vidhrdw/frogger.o obj/sndhrdw/frogger.o obj/drivers/frogger.o \
!          obj/machine/scramble.o obj/sndhrdw/scramble.o obj/drivers/scramble.o \
!          obj/drivers/scobra.o \
!          obj/machine/warpwarp.o obj/vidhrdw/warpwarp.o obj/drivers/warpwarp.o \
!          obj/vidhrdw/popeye.o obj/sndhrdw/popeye.o obj/drivers/popeye.o \
!          obj/vidhrdw/amidar.o obj/sndhrdw/amidar.o obj/drivers/amidar.o \
!          obj/vidhrdw/rallyx.o obj/drivers/rallyx.o \
!          obj/vidhrdw/pooyan.o obj/sndhrdw/pooyan.o obj/drivers/pooyan.o \
!          obj/sndhrdw/timeplt.o obj/vidhrdw/timeplt.o obj/drivers/timeplt.o \
!          obj/vidhrdw/locomotn.o obj/drivers/locomotn.o \
!          obj/machine/phoenix.o obj/vidhrdw/phoenix.o obj/sndhrdw/phoenix.o obj/drivers/phoenix.o \
!          obj/sndhrdw/pleiads.o \
!          obj/machine/carnival.o obj/vidhrdw/carnival.o obj/sndhrdw/carnival.o obj/drivers/carnival.o \
!          obj/machine/invaders.o obj/vidhrdw/invaders.o obj/sndhrdw/invaders.o obj/drivers/invaders.o \
!          obj/vidhrdw/mario.o obj/drivers/mario.o \
!          obj/vidhrdw/zaxxon.o obj/drivers/zaxxon.o \
!          obj/vidhrdw/congo.o obj/drivers/congo.o \
!          obj/vidhrdw/bombjack.o obj/sndhrdw/bombjack.o obj/drivers/bombjack.o \
!          obj/machine/centiped.o obj/vidhrdw/centiped.o obj/drivers/centiped.o \
!          obj/machine/milliped.o obj/vidhrdw/milliped.o obj/drivers/milliped.o \
!          obj/machine/warlord.o obj/vidhrdw/warlord.o obj/drivers/warlord.o \
!          obj/machine/vanguard.o obj/vidhrdw/vanguard.o obj/sndhrdw/vanguard.o obj/drivers/vanguard.o \
!          obj/vidhrdw/nibbler.o obj/drivers/nibbler.o \
!          obj/machine/mpatrol.o obj/vidhrdw/mpatrol.o obj/drivers/mpatrol.o \
!          obj/vidhrdw/btime.o obj/sndhrdw/btime.o obj/drivers/btime.o \
!          obj/sndhrdw/jumpbug.o obj/vidhrdw/jumpbug.o obj/drivers/jumpbug.o \
!          obj/machine/gberet.o obj/vidhrdw/gberet.o obj/sndhrdw/gberet.o obj/drivers/gberet.o \
!          obj/vidhrdw/exidy.o obj/drivers/venture.o obj/drivers/pepper2.o obj/drivers/mtrap.o \
!          obj/vidhrdw/gottlieb.o obj/drivers/reactor.o \
!          obj/sndhrdw/gottlieb.o obj/drivers/qbert.o \
!          obj/machine/gottlieb.o obj/drivers/krull.o \
!          obj/drivers/qbertqub.o \
!          obj/drivers/mplanets.o \
!          obj/drivers/3stooges.o \
!          obj/vidhrdw/taito.o obj/sndhrdw/junglek.o obj/drivers/junglek.o \
!          obj/machine/elevator.o obj/sndhrdw/elevator.o obj/drivers/elevator.o \
!          obj/drivers/wwestern.o \
!          obj/machine/panic.o obj/vidhrdw/panic.o obj/drivers/panic.o \
!          obj/machine/arabian.o obj/vidhrdw/arabian.o obj/sndhrdw/arabian.o obj/drivers/arabian.o \
!          obj/machine/1942.o obj/vidhrdw/1942.o obj/drivers/1942.o obj/sndhrdw/capcom.o \
!          obj/machine/vulgus.o obj/sndhrdw/vulgus.o obj/vidhrdw/vulgus.o obj/drivers/vulgus.o \
!          obj/vidhrdw/commando.o obj/drivers/commando.o \
!          obj/machine/gng.o obj/vidhrdw/gng.o obj/drivers/gng.o \
!          obj/vidhrdw/sonson.o obj/drivers/sonson.o \
!          obj/vidhrdw/exedexes.o obj/drivers/exedexes.o \
!          obj/sndhrdw/gyruss.o obj/vidhrdw/gyruss.o obj/drivers/gyruss.o \
!          obj/machine/superpac.o obj/vidhrdw/superpac.o obj/drivers/superpac.o \
!          obj/machine/galaga.o obj/vidhrdw/galaga.o obj/drivers/galaga.o \
!          obj/machine/kangaroo.o obj/sndhrdw/kangaroo.o obj/vidhrdw/kangaroo.o obj/drivers/kangaroo.o \
!          obj/sndhrdw/kungfum.o obj/vidhrdw/kungfum.o obj/drivers/kungfum.o \
!          obj/machine/qix.o obj/vidhrdw/qix.o obj/drivers/qix.o \
!          obj/machine/williams.o obj/sndhrdw/williams.o obj/vidhrdw/williams.o obj/drivers/williams.o \
!          obj/machine/starforc.o obj/sndhrdw/starforc.o obj/vidhrdw/starforc.o obj/drivers/starforc.o \
!          obj/machine/naughtyb.o obj/vidhrdw/naughtyb.o obj/drivers/naughtyb.o \
!          obj/machine/mystston.o obj/vidhrdw/mystston.o obj/drivers/mystston.o \
!          obj/machine/tutankhm.o obj/sndhrdw/tutankhm.o obj/vidhrdw/tutankhm.o obj/drivers/tutankhm.o \
!          obj/machine/spacefb.o obj/vidhrdw/spacefb.o obj/drivers/spacefb.o \
!          obj/machine/mappy.o obj/sndhrdw/mappy.o obj/vidhrdw/mappy.o obj/drivers/mappy.o \
!          obj/machine/ccastles.o obj/vidhrdw/ccastles.o obj/drivers/ccastles.o \
!          obj/machine/yiear.o obj/vidhrdw/yiear.o obj/drivers/yiear.o \
!          obj/machine/digdug.o obj/vidhrdw/digdug.o obj/drivers/digdug.o \
!          obj/machine/asteroid.o obj/sndhrdw/asteroid.o \
! 		 obj/machine/atari_vg.o obj/vidhrdw/atari_vg.o obj/drivers/asteroid.o \
!          obj/drivers/bwidow.o \
!          obj/machine/bzone.o obj/drivers/bzone.o \
!          obj/drivers/llander.o obj/machine/llander.o \
!          obj/drivers/redbaron.o obj/machine/redbaron.o \
!          obj/machine/spacduel.o \
!          obj/drivers/tempest.o obj/machine/tempest.o \
!          obj/machine/starwars.o obj/machine/swmathbx.o obj/drivers/starwars.o obj/sndhrdw/starwars.o \
!          obj/machine/missile.o obj/vidhrdw/missile.o obj/drivers/missile.o \
!          obj/machine/bublbobl.o obj/vidhrdw/bublbobl.o obj/drivers/bublbobl.o \
!          obj/vidhrdw/eggs.o obj/drivers/eggs.o \
!          obj/machine/bosco.o obj/sndhrdw/bosco.o obj/vidhrdw/bosco.o obj/drivers/bosco.o \
!          obj/vidhrdw/yard.o obj/drivers/yard.o \
!          obj/vidhrdw/blueprnt.o obj/sndhrdw/blueprnt.o obj/drivers/blueprnt.o \
!          obj/vidhrdw/sega.o obj/sndhrdw/sega.o obj/machine/sega.o obj/drivers/sega.o \
!          obj/sndhrdw/omegrace.o obj/machine/omegrace.o obj/drivers/omegrace.o \
!          obj/vidhrdw/xevious.o obj/machine/xevious.o obj/drivers/xevious.o \
!          obj/vidhrdw/bankp.o obj/sndhrdw/bankp.o obj/drivers/bankp.o \
!          obj/vidhrdw/sbasketb.o obj/drivers/sbasketb.o \
!          obj/machine/mcr.o obj/sndhrdw/mcr.o \
!          obj/vidhrdw/mcr1.o obj/vidhrdw/mcr2.o obj/vidhrdw/mcr3.o \
!          obj/drivers/mcr1.o obj/drivers/mcr2.o obj/drivers/mcr3.o \
!          obj/machine/espial.o obj/vidhrdw/espial.o obj/drivers/espial.o \
!          obj/machine/tp84.o obj/vidhrdw/tp84.o obj/sndhrdw/tp84.o obj/drivers/tp84.o \
!          obj/vidhrdw/rastan.o obj/sndhrdw/rastan.o obj/drivers/rastan.o \
!          obj/Z80/Z80.o obj/M6502/M6502.o obj/I86/I86.o obj/M6809/m6809.o \
!          obj/M68000/opcode0.o obj/M68000/opcode1.o obj/M68000/opcode2.o obj/M68000/opcode3.o obj/M68000/opcode4.o obj/M68000/opcode5.o \
!          obj/M68000/opcode6.o obj/M68000/opcode7.o obj/M68000/opcode8.o obj/M68000/opcode9.o obj/M68000/opcodeb.o \
!          obj/M68000/opcodec.o obj/M68000/opcoded.o obj/M68000/opcodee.o obj/M68000/mc68kmem.o \
!          obj/M68000/cpufunc.o
  
  VPATH = src src/Z80 src/M6502 src/I86 src/M6809 src/pactape
  
! all: mame.exe
  
! mame.exe:  $(OBJS)
! 	$(LD) -s -o mame.exe $(OBJS) $(DJDIR)/lib/audiodjf.a $(LIBS)
  
  obj/osdepend.o: src/msdos/msdos.c
--- 10,26 ----
           obj/pactape/pactape.o obj/pactape/pactree.o obj/pactape/paclearn.o \
           obj/pactape/pacthink.o \
!          obj/sndhrdw/ym2203.opm \
           obj/machine/z80fmly.o \
           obj/vidhrdw/generic.o obj/sndhrdw/generic.o \
           obj/machine/pacman.o obj/drivers/pacman.o \
!          obj/vidhrdw/pengo.o obj/sndhrdw/pengo.o \
!          obj/Z80/Z80.o 
  
  VPATH = src src/Z80 src/M6502 src/I86 src/M6809 src/pactape
  
! all: pactape.exe
  
! pactape.exe:  $(OBJS)
! 	$(LD) -s -o pactape.exe $(OBJS) $(DJDIR)/lib/audiodjf.a $(LIBS)
  
  obj/osdepend.o: src/msdos/msdos.c
***************
*** 161,163 ****
  	del obj\vidhrdw\*.o
  	del obj\sndhrdw\*.o
! 	del mame.exe
--- 52,54 ----
  	del obj\vidhrdw\*.o
  	del obj\sndhrdw\*.o
! 	del pactape.exe
diff -rC2 s0/src/cpuintrf.c s1/src/cpuintrf.c
*** s0/src/cpuintrf.c	Sun Sep  7 20:50:00 1997
--- s1/src/cpuintrf.c	Tue Sep  9 11:46:20 1997
***************
*** 11,20 ****
  #include "driver.h"
  #include "Z80.h"
! #include "M6502.h"
! #include "M6809.h"
! #include "M68000.h"
  
- void I86_Execute();
- void I86_Reset(unsigned char *mem,int cycles);
  
  
--- 11,16 ----
  #include "driver.h"
  #include "Z80.h"
! int cpu_interrupt(void);
  
  
  
***************
*** 64,76 ****
  };
  
- /* DS...*/
- struct m6809context
- {
- 	m6809_Regs	regs;
- 	int	icount;
- 	int iperiod;
- 	int	irq;
- };
- /* ...DS */
  
  
--- 60,63 ----
***************
*** 390,426 ****
  				}
  				break;
- 			case CPU_M6502:
- 				{
- 					M6502 *ctxt;
- 
- 
- 					ctxt = (M6502 *)cpucontext[activecpu];
- 					ctxt->IPeriod = cycles;	/* must be done before Reset6502() */
- 					Reset6502(ctxt);
- 				}
- 				break;
- 			case CPU_I86:
- 				I86_Reset(RAM,cycles);
- 				break;
- 			/* DS... */
- 			case CPU_M6809:
- 				{
- 					struct m6809context *ctxt;
- 
- 					ctxt = (struct m6809context *)cpucontext[activecpu];
- 					m6809_IPeriod = cycles;
- 					m6809_reset();
- 					m6809_GetRegs(&ctxt->regs);
- 					ctxt->icount = cycles;
- 					ctxt->iperiod = cycles;
- 					ctxt->irq = INT_NONE;
- 				}
- 				break;
- 			/* ...DS */
- 			case CPU_M68000:
- 				{
- 					MC68000_reset(cycles);
- 				}
- 				break;
  		}
  	}
--- 377,380 ----
***************
*** 468,528 ****
  						break;
  
- 					case CPU_M6502:
- 							iperiod = ((M6502 *)cpucontext[activecpu])->IPeriod;
- 							for (iloops = Machine->drv->cpu[activecpu].interrupts_per_frame - 1;
- 									iloops >= 0;iloops--)
- 							{
- 							/* TODO: keep track of differences between the requested number */
- 							/* of cycles and the actual cycles executed. */
- 								totalcycles[activecpu] += Run6502((M6502 *)cpucontext[activecpu],iperiod);
- 								cpu_cause_interrupt(activecpu,cpu_interrupt());
- 							}
- 						break;
- 
- 					case CPU_I86:
- /* TODO: retrieve iperiod from the CPU context (needed by cpu_getfcount()) */
- 							for (iloops = Machine->drv->cpu[activecpu].interrupts_per_frame - 1;
- 									iloops >= 0;iloops--)
- 							{
- 								I86_Execute();
- 								totalcycles[activecpu] += iperiod;
- 							}
- 						break;
- 					/* DS... */
- 					case CPU_M6809:
- 						{
- 							struct m6809context *ctxt;
- 
- 							ctxt = (struct m6809context *)cpucontext[activecpu];
- 
- 							m6809_SetRegs(&ctxt->regs);
- 							m6809_ICount = ctxt->icount;
- 							iperiod = m6809_IPeriod = ctxt->iperiod;
- 							m6809_IRequest = ctxt->irq;
- 
- 							for (iloops = Machine->drv->cpu[activecpu].interrupts_per_frame - 1;
- 									iloops >= 0;iloops--)
- 							{
- 								m6809_execute();
- 								totalcycles[activecpu] += iperiod;
- 							}
- 
- 							m6809_GetRegs(&ctxt->regs);
- 							ctxt->icount = m6809_ICount;
- 							ctxt->iperiod = m6809_IPeriod;
- 							ctxt->irq = m6809_IRequest;
- 						}
- 						break;
- 					/* ...DS */
- 					case CPU_M68000:
- 						{
- 							for (iloops = Machine->drv->cpu[activecpu].interrupts_per_frame - 1;
- 									iloops >= 0;iloops--)
- 							{
- 								MC68000_Execute();
- 								totalcycles[activecpu] += iperiod;
- 							}
- 						}
- 						break;
  
  
--- 422,425 ----
***************
*** 539,543 ****
  		{
  			usres = 0;
! 			yield_cpu = FALSE;
  		}
  		else
--- 436,440 ----
  		{
  			usres = 0;
! 			yield_cpu = 0;
  		}
  		else
***************
*** 609,621 ****
  			break;
  
- 		case CPU_M6502:
- 			return ((M6502 *)cpucontext[activecpu])->PC.W;
- 			break;
- 
- 		/* DS... */
- 		case CPU_M6809:
- 			return m6809_GetPC();
- 			break;
- 		/* ...DS */
  
  		default:
--- 506,509 ----
***************
*** 641,647 ****
  	switch(Machine->drv->cpu[activecpu].cpu_type & ~CPU_FLAGS_MASK)
  	{
- 		case CPU_M6502:
- 			return ((M6502 *)cpucontext[activecpu])->previousPC.W;
- 			break;
  
  		default:
--- 529,532 ----
***************
*** 717,729 ****
  			break;
  
- 		case CPU_M6502:
- 			return ((M6502 *)cpucontext[activecpu])->ICount;
- 			break;
- 
- 		/* DS... */
- 		case CPU_M6809:
- 			return m6809_ICount;
- 			break;
- 		/* ...DS */
  
  		default:
--- 602,605 ----
***************
*** 749,761 ****
  			break;
  
- 		case CPU_M6502:
- 			return ((M6502 *)cpucontext[activecpu])->ICount + iloops * iperiod;
- 			break;
- 
- 		/* DS... */
- 		case CPU_M6809:
- 			return m6809_ICount + iloops * iperiod;
- 			break;
- 		/* ...DS */
  
  		default:
--- 625,628 ----
***************
*** 788,800 ****
  			break;
  
- 		case CPU_M6502:
- 			((M6502 *)cpucontext[activecpu])->ICount = cycles;
- 			break;
- 
- 		/* DS... */
- 		case CPU_M6809:
- 			m6809_ICount = cycles;
- 			break;
- 		/* ...DS */
  
  		default:
--- 655,658 ----
***************
*** 857,869 ****
  			break;
  
- 		case CPU_M6502:
- 			{
- 				M6502 *ctxt;
- 
- 
- 				ctxt = (M6502 *)cpucontext[cpu];
- 				M6502_Cause_Interrupt(ctxt,type);
- 			}
- 			break;
  
  		default:
--- 715,718 ----
***************
*** 898,910 ****
  			break;
  
- 		case CPU_M6502:
- 			{
- 				M6502 *ctxt;
- 
- 
- 				ctxt = (M6502 *)cpucontext[cpu];
- 				M6502_Clear_Pending_Interrupts(ctxt);
- 			}
- 			break;
  
  		default:
--- 747,750 ----
***************
*** 953,967 ****
  			break;
  
- 		case CPU_M6502:
- 			if (interrupt_enable == 0) return INT_NONE;
- 			else return INT_IRQ;
- 			break;
- 
- 		/* DS... */
- 		case CPU_M6809:
- 			if (interrupt_enable == 0) return INT_NONE;
- 			else return INT_IRQ;
- 			break;
- 		/* ...DS */
  
  		default:
--- 793,796 ----
***************
*** 983,990 ****
  			break;
  
- 		case CPU_M6502:
- 			if (interrupt_enable == 0) return INT_NONE;
- 			else return INT_NMI;
- 			break;
  
  		default:
--- 812,815 ----
***************
*** 1005,1017 ****
  			break;
  
- 		case CPU_M6502:
- 			return INT_NONE;
- 			break;
- 
- 		/* DS... */
- 		case CPU_M6809:
- 			return INT_NONE;
- 			break;
- 		/* ...DS */
  
  		default:
--- 830,833 ----
