#ifndef PACLEARN_H
#define PACLEARN_H

/* Directions */
#define dD 0x8   /* 1000 */
#define dR 0x4   /* 0100 */
#define dL 0x2   /* 0010 */
#define dU 0x1   /* 0001 */
#define dX 0x0   /* 0000 */
/* Masks */
#define mD 0x7   /* 0111 */
#define mR 0xb   /* 1011 */
#define mL 0xd   /* 1101 */
#define mU 0xe   /* 1110 */
#define mX 0xf   /* 1111 */

/* VID macro used for maze only: top two lines excluded
   VID[0,0] => location (0,2) */
#define VID(x,y) videoram [0x3a0 - 0x20 * (x) + (y)]


/* DEBUGGING tools */
#if 0
#define PT_DEBUG
#endif

void debug_msg (char * text);
#ifdef PT_DEBUG
extern char debugText[6][28];
#endif

#endif /* PACLEARN_H */
